-- Deathrun script by Danikel
maximumTerrorists = 1 -- Number of maximum terrorists
maximumPlayerLives = 0 -- Number of maximum player lives (if died, respawn)
admins = {30584} -- If you're rcon, you do not must write here. or if you're hosting server from game, I recommend write here your USGN ID.

version="0.7.9" -- Unstable version

lives = {}
originx = {}
originy = {}

selected=0
equipKnife=0

timer(5000, "death_author")

function death_existsData(arr, data)
	local exists = false
	for i = 0,table.getn(arr) do
		if (arr[i]==data) then
			exists=true
		end
	end
	return exists
end

function death_author()
	msg("255000000------------------")
	msg("000255000Author255255000: Danikel")
	msg("000255000Version255255000: "..version)
	msg("255000000------------------")
	timer(60000, "death_author")
end

addhook("join", "death_playerJoin")
function death_playerJoin(id)
	lives[id]=0
end

addhook("startround", "death_roundStart")
function death_roundStart(mode)
	selected=0
	local frags = 1
	for i = 0,32 do
		if (player(i,"exists") and player(i,"team")==2) then
			lives[i]=maximumPlayerLives
			if (player(i,"score")>frags) then
				frags=player(i,"score")
			end
		end
	end
	for i = 0,32 do
		if (player(i,"exists") and player(i,"team")==2 and player(i,"score")==frags) then
			local img = image("gfx/flare3.bmp", 0, 0, 100+i)
			imageblend(img, 1)
			imagecolor(img, 0, 255, 0)
			msg2(i, "[Deathrun] You're best player.")
		end
	end
	
	local ts = 0
	for i = 0,32 do
		if (player(i,"exists") and player(i,"team")==1) then
			ts = ts + 1
		end
	end
	if (ts>maximumTerrorists) then
		parse("endround 0")
	end
end

addhook("spawn", "death_playerSpawn")
function death_playerSpawn(id)
	originx[id]=player(id,"x")
	originy[id]=player(id,"y")
end

addhook("endround", "death_roundEnd")
function death_roundEnd()
	local deadCts = {}
	local cts = 0
	local ts = 0
	local tts = {}
	for i = 0,32 do
		if (player(i,"exists") and player(i,"team")==2 and player(i,"health")<=0) then
			deadCts[cts]=i
			cts=cts+1
		elseif (player(i,"exists") and player(i,"team")==1) then
			tts[ts]=i
			ts=ts+1
		end
	end
	if (not cts==0) then
		if (selected==0) then
			for i=0,table.getn(ts) do
				parse("makect "..ts[i])
			end
		end
		local next = deadCts[math.random(cts)]
		selected=selected+1
		parse("maket "..next)
		msg("[Deathrun] Next terrorist is "..player(next,"name"))
		if (not selected==maximumTerrorists) then
			death_roundEnd()
		end
	elseif (table.getn(tts)+1>maximumTerrorists) then
		for i=0,table.getn(tts)-maximumTerrorists do
			parse("makect "..tts[i])
			local death = player(tts[i],"deaths") - 1
			parse("setdeaths "..tts[i].." "..death)
		end
	end
end

addhook("die", "death_playerDie")
function death_playerDie(victim, killer)
	if (player(killer,"team")==2 and player(victim,"team")==1) then
		local ts = player(0,"team1living")
		if (table.getn(ts)>0) then
			msg("[Deathrun] Player "..player(killer,"name").." killed terrorist.")
		else
			msg("[Deathrun] Player "..player(killer,"name").." killed last terrorist.")
		end
	elseif (killer==0 and player(victim, "team")==2) then
		lives[victim]=lives[victim] - 1
		if (lives[victim]>-1) then
			parse("spawnplayer "..victim.." "..originx[victim].." "..originy[victim])
			local death = player(victim,"deaths") - 1
			parse("setdeaths "..victim.." "..death)
			msg2(victim, "[Deathrun] You're respawned, -1 live, no death added")
			equipKnife=victim
			timer(500, "death_playerKnife")
		end
	end
end

function death_playerKnife(txt, id)
	parse("equip "..equipKnife.." 50")
	parse("setweapon "..equipKnife.." 50")
end

addhook("say", "death_playerSay")
function death_playerSay(id, txt)
	if (txt=="!deathrun") then
		if (player(id,"rcon") or death_existsData(admins, player(id,"usgn"))) then
			menu(id, "Deathrun Menu,Maximum Terrorists|"..maximumTerrorists..",Maximum Player Lives|"..maximumPlayerLives..",Add Live,Remove Live")
			return 1
		end
	end
end

addhook("menu", "death_playerMenu")
function death_playerMenu(id, mn, sel)
	if (mn=="Deathrun Menu") then
		if (sel==1) then
			menu(id, "Deathrun Menu - Maximum Terrorists,1,2,3")
		elseif (sel==2) then
			menu(id, "Deathrun Menu - Maximum Player Lives,0,1,2")
		elseif (sel==3) then
			local str = "Deathrun Menu - Add Life,"
			for i = 0,32 do
				if (player(i,"exists") and player(i,"team")==2 and lives[i]<2) then
					str = str..player(i,"name").."|"..lives[i].." Lives,"
				end
			end
			menu(id, str)
		elseif (sel==4) then
			local str = "Deathrun Menu - Remove Life,"
			for i = 0,32 do
				if (player(i,"exists") and player(i,"team")==2 and lives[i]>0) then
					str = str..player(i,"name").."|"..lives[i].." Lives,"
				end
			end
			menu(id, str)
		end
	elseif (mn=="Deathrun Menu - Maximum Terrorists") then
		maximumTerrorists=sel
	elseif (mn=="Deathrun Menu - Maximum Player Lives") then
		maximumPlayerLives=sel - 1
	elseif (mn=="Deathrun Menu - Add Life") then
		lives[sel]=lives[sel] + 1
		msg2(id, "[Deathrun] You are gave +1 live to player "..player(sel,"name").."!")
		msg2(sel, "[Deathrun] You got +1 live from admin "..player(id,"name").."!")
	elseif (mn=="Deathrun Menu - Remove Life") then
		lives[sel]=lives[sel] - 1
		msg2(id, "[Deathrun] You are removed -1 live from player "..player(sel,"name").."!")
		msg2(sel, "[Deathrun] Admin "..player(id,"name").." has removed your live -1!")
	end
end